package com.liang.dao;

import com.liang.entity.BaseProjectbudget;
import com.liang.entity.StaBudget;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 经费预算(StaBudget)表数据库访问层
 *
 * @author makejava
 * @since 2023-04-09 22:07:01
 */
public interface StaBudgetDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaBudget queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param staBudget 查询条件
     * @param pageable  分页对象
     * @return 对象列表
     */
    List<StaBudget> queryAllByLimit(StaBudget staBudget, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param staBudget 查询条件
     * @return 总行数
     */
    long count(StaBudget staBudget);

    /**
     * 新增数据
     *
     * @param staBudget 实例对象
     * @return 影响行数
     */
    int insert(StaBudget staBudget);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaBudget> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<BaseProjectbudget> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaBudget> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StaBudget> entities);

    /**
     * 修改数据
     *
     * @param staBudget 实例对象
     * @return 影响行数
     */
    int update(StaBudget staBudget);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 根据项目删除数据
     *
     * @param xm
     * @return
     */
    int deleteByXm(Integer xm);

    /**
     * 更新预算
     *
     * @param staBudgets
     * @return
     */
    int updateBatch(List<StaBudget> staBudgets);

    /**
     * 根据项目类型（项目模板）插入
     *
     * @param xmlx
     * @return
     */
    int insertBatchByXmlx(String xmlx, Integer xm);

    /**
     * 获取经费列表
     *
     * @return
     */
    List<StaBudget> getBudgetList(Integer xm);
}

